# Mini ProbZelus

# Install

You need to install the Zelus compiler:

```bash
$ opam install zelus
```

For the example, you also need to install `zelus-io`.
Instructions can be found here: https://github.com/IBM/probzelus

Tested with OCaml 5.1.1 

# Organization

- `rppl.ml`: implementation of mini ProbZelus (`sample`, `observe`, `infer`)
- `rppl.zli`: inferface (type signatures) for the Zelus compiler
- `distribution.[ml, mli]`: small distributions library

# Test

The file `hmm.zls` contains a simplify tracker model.
You can build the runtime and the example with:

```bash
$ dune build
```

This command generates an executable `hmm_main.exe` which prints at each time step the observation and the estimated position on `stdout`.

```bash
$ ./hmm_main.exe | head -n 10
0.250276 -0.057848 
1.999288 0.303194 
3.918275 1.376934 
3.794972 2.950067 
6.565236 3.531081 
5.797134 5.349273 
5.934739 5.556215 
8.131860 5.770963 
7.855593 7.231576 
8.511391 7.646757 
...
^C
```

An easy way to visualize the results is to use [`feedgnuplot`](https://github.com/dkogan/feedgnuplot)

```bash
$ ./hmm_main.exe | feedgnuplot --stream 0.05 # Stream stdout, never stops
$ ./hmm_main.exe | head -n 100 | feedgnuplot # only show the first 100 steps
```